﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using ThinkGeo.MapSuite.MvcEdition;
using ThinkGeo.MapSuite.Core;
using System.Collections.ObjectModel;

namespace DisplayASimpleMapForMvc.Controllers
{
    public class IndexController : Controller
    {
        //
        // GET: /UseDraggableMarkers/

        public ActionResult Index()
        {
            return View();
        }

        [MapActionFilter]
        public JsonResult ClickOnFeature(Map map, GeoCollection<object> args)
        {
            PointShape point = new PointShape(Convert.ToDouble(args[0]), Convert.ToDouble(args[1]));

            ShapeFileFeatureLayer worldLayer = (ShapeFileFeatureLayer)((LayerOverlay)map.CustomOverlays[1]).Layers["WorldLayer"];

            worldLayer.Open();
            Collection<Feature> selectedFeatures = worldLayer.QueryTools.GetFeaturesContaining(point, new string[0]);
            worldLayer.Close();

            JsonResult result = new JsonResult();
            if (selectedFeatures.Count > 0)
            {
                result.Data = selectedFeatures[0].GetWellKnownText();
            }
            return result;
        }
    }
}
